/**
 * Arduino Uno - NeoPixel Potentiometer
 * v. 1.0
 * Copyright (C) 2015 Robert Ulbricht
 * see <http://www.arduinoslovakia.eu>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <Adafruit_NeoPixel.h>

// Which pin on the Arduino is connected to the NeoPixels?
#define PIN            6

// How many NeoPixels are attached to the Arduino?
#define NUMPIXELS      8

// delay
#define POT1 A0
// intensity
#define POT2 A1
// color
#define POT3 A2

// When we setup the NeoPixel library, we tell it how many pixels, and which pin to use to send signals.
// Note that for older NeoPixel strips you might need to change the third parameter--see the strandtest
// example for more information on possible values.
Adafruit_NeoPixel pixels = Adafruit_NeoPixel(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);

int delayval = 100; // delay for half a second
int state = 0;

void setup()
{
pixels.begin(); // This initializes the NeoPixel library.
}

void loop()
{
int intensity;
for(int i=0;i<NUMPIXELS;i++)
  {
  intensity=analogRead(POT2)/NUMPIXELS/8*(i+1);
  //pixels.setPixelColor(i, pixels.Color(intensity*i+intensity,0,0));
  //pixels.setBrightness(intensity/8*i);
  uint32_t c=Wheel(analogRead(POT3)/4);
      uint8_t
      r = (uint8_t)(c >> 16),
      g = (uint8_t)(c >>  8),
      b = (uint8_t)c;
      r = (r * intensity) >> 8;
      g = (g * intensity) >> 8;
      b = (b * intensity) >> 8;

  pixels.setPixelColor(i, pixels.Color(r,g,b));
  pixels.show(); // This sends the updated pixel color to the hardware.
  delayval=analogRead(POT1);  
  delay(delayval); // Delay for a period of time (in milliseconds).
  }
  
for(int i=0;i<NUMPIXELS;i++)
  {
  intensity=analogRead(POT2)/NUMPIXELS/8;
  pixels.setPixelColor(i, pixels.Color(0,0,0)); // Black
  pixels.show(); // This sends the updated pixel color to the hardware.
  delayval=analogRead(POT1);  
  delay(delayval); // Delay for a period of time (in milliseconds).
  }
}

// Input a value 0 to 255 to get a color value.
// The colours are a transition r - g - b - back to r.
uint32_t Wheel(byte WheelPos) {
  WheelPos = 255 - WheelPos;
  if(WheelPos < 85) {
   return pixels.Color(255 - WheelPos * 3, 0, WheelPos * 3);
  } else if(WheelPos < 170) {
    WheelPos -= 85;
   return pixels.Color(0, WheelPos * 3, 255 - WheelPos * 3);
  } else {
   WheelPos -= 170;
   return pixels.Color(WheelPos * 3, 255 - WheelPos * 3, 0);
  }
}

